require "util"
require "story"
require "defines"

script.on_event(defines.events, function(event)
	local speed = game.speed
	if event.name == defines.events.on_player_created then
		-- GUI
		game.player.gui.top.add{name = "display", type = "label", caption = "Speed "..tostring(format_num(speed,2,"x","")), style="caption_label_style"}
		local button_decrease = game.player.gui.top.add{name = "decrease", type = "button", caption = "<", style="button_style"}
		local button_increase = game.player.gui.top.add{name = "increase", type = "button", caption = ">", style="button_style"}
		
		
	elseif event.name == defines.events.on_gui_click then
		local click = event.element

		if click.name == "increase" then
			for playerIndex, player in pairs(game.players) do
				if player.gui.top.increase then
					if speed < 10.0 then
						speed = speed + 0.5
						player.gui.top.display.caption = "Speed "..tostring(format_num(speed,2,"x",""))
						game.speed = speed
					end
				end
			end
		elseif click.name == "decrease" then
			for playerIndex, player in pairs(game.players) do
				if player.gui.top.decrease then
					if speed > 0.5 then
						speed = speed - 0.5
						player.gui.top.display.caption = "Speed "..tostring(format_num(speed,2,"x",""))
						game.speed = speed
					end
				end
			end
		end
	end
end)

function format_num(amount, decimal, prefix, neg_prefix)
  local str_amount,  formatted, famount, remain

  decimal = decimal or 2  -- default 2 decimal places
  neg_prefix = neg_prefix or "-" -- default negative sign

  famount = math.abs(round(amount,decimal))
  famount = math.floor(famount)

  remain = round(math.abs(amount) - famount, decimal)

        -- comma to separate the thousands
  formatted = comma_value(famount)

        -- attach the decimal portion
  if (decimal > 0) then
    remain = string.sub(tostring(remain),3)
    formatted = formatted .. "." .. remain ..
                string.rep("0", decimal - string.len(remain))
  end

        -- attach prefix string e.g '$' 
  formatted = (prefix or "") .. formatted 

        -- if value is negative then format accordingly
  if (amount<0) then
    if (neg_prefix=="()") then
      formatted = "("..formatted ..")"
    else
      formatted = neg_prefix .. formatted 
    end
  end

  return formatted
end

function round(val, decimal)
  if (decimal) then
    return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
  else
    return math.floor(val+0.5)
  end
end

function comma_value(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end